'*******************************************************************************
'* hmht@CpNX
'*******************************************************************************
'* gp() * 
'*   Dim m_cIni As New cIni(t@C)
'*  擾
'*   m_cIni.GetIniString(ZNV, L[, 擾s̖߂l[ȗ])
'*  
'*   m_cIni.SetIniString(ZNV, L[, ޒl)
'*******************************************************************************

Imports System
Imports System.Text
Imports System.Runtime.InteropServices

Public Class cIni

    Private mSection As String  'ZNV
    '* DEFINE
    Private Const BUFF_LEN As Integer = 256 '256

    '* API錾
    '--- ini̧ٓǍ
    Private Declare Auto Function GetPrivateProfileString Lib "kernel32.dll" _
        Alias "GetPrivateProfileString" ( _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpApplicationName As String, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpKeyName As String, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpDefault As String, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpReturnedString As StringBuilder, _
        ByVal nSize As UInt32, _
        <MarshalAs(UnmanagedType.LPTStr)> ByVal lpFileName As String) As UInt32

    '--- ZNV̑SẴL[Ƃ̒l擾
    <System.Runtime.InteropServices.DllImport("kernel32.dll", CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Private Shared Function GetPrivateProfileSection( _
    ByVal appName As String, _
    ByVal returnedString As Byte(), _
    ByVal bufferSize As UInt32, _
    ByVal fileName As String) As UInt32
    End Function

    '--- iniُ̧
    <DllImport("kernel32.dll")> _
    Private Shared Function WritePrivateProfileString _
      (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFilename As String) As Boolean
    End Function

    '* oϐ
    Private m_strIniFileName As String

    '* o֐

    '--- CX^X쐬
    '*  : init@C̃tpX
    Public Sub New(ByVal strIniFileName As String)
        'oϐɃZbg
        m_strIniFileName = strIniFileName
    End Sub

    '--- \[X蓮ŊJ
    Public Sub Close()
        Call Finalize()
    End Sub

    '--- \[X(KvȂAIɊJ)
    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

    '--- Get ini String
    Public Function GetIniString( _
            ByVal lpszEntry As String _
        ) As String

        Return GetIniString(mSection, lpszEntry)
    End Function

    '--- Get ini String
    Public Function GetIniString( _
            ByVal lpszSection As String, _
            ByVal lpszEntry As String, _
            Optional ByVal lpszDefault As String = Nothing _
        ) As String

        Dim sb As StringBuilder = New StringBuilder(BUFF_LEN)
        Dim ret As UInt32 = GetPrivateProfileString(lpszSection, lpszEntry, lpszDefault, sb, Convert.ToUInt32(sb.Capacity), m_strIniFileName)

        Return sb.ToString
    End Function

    '--- Set ini String
    Public Function SetIniString( _
            ByVal lpszEntry As String, _
            ByVal lpszString As String _
        ) As Boolean

        Return SetIniString(mSection, lpszEntry, lpszString)
    End Function

    '--- Set ini String
    Public Function SetIniString( _
            ByVal lpszSection As String, _
            ByVal lpszEntry As String, _
            ByVal lpszString As String _
        ) As Boolean

        Return WritePrivateProfileString(lpszSection, lpszEntry, lpszString, m_strIniFileName)
    End Function

    Public Property Section() As String
        Get
            Return mSection
        End Get
        Set(ByVal Value As String)
            mSection = Value
        End Set
    End Property

    Public Function GetKeys() As String()

        Return GetKeys(mSection)
    End Function

    Public Function GetKeys( _
            ByVal lpszSection As String _
        ) As String()

        Dim sb(&H7FFF) As Byte
        Dim ret As UInt32 = GetPrivateProfileSection(lpszSection, sb, Convert.ToUInt32(&H7FFF), m_strIniFileName)

        Dim b() As Byte
        Dim I, J As Integer
        Dim sText() As String

        For I = 0 To CInt(ret.ToString) * 2 - 1 Step 2
            ReDim Preserve b(J + 1)
            If sb(I) = 0 And sb(I + 1) = 0 Then
                b(J) = &H0
                b(J) = &H9
            Else
                b(J) = sb(I)
                b(J + 1) = sb(I + 1)
            End If
            J = J + 2
        Next

        If b Is Nothing Then Return sText

        sText = System.Text.Encoding.Unicode.GetString(b).Split(vbTab)
        ReDim Preserve sText(UBound(sText) - 1)

        Return sText
    End Function
End Class